package TWiki::Plugins::MasonPlugin::SessionTieHash;

use strict;

sub TIEHASH {
	return bless {}, $_[0];
}

sub FETCH {
	my $value = TWiki::Func::getSessionValue($_[1]);
	return UNIVERSAL::isa($value, 'UNIVERSAL') ? bless($value, ref($value)) : $value;
}

sub STORE {
	return TWiki::Func::setSessionValue($_[1], $_[2]);
}

sub DELETE {
	return TWiki::Func::clearSessionValue($_[1]);
}

sub EXISTS {
	return TWiki::Func::getSessionValue($_[1]);
}

1;
